"""LCM type definitions
This file automatically generated by lcm.
DO NOT MODIFY BY HAND!!!!
"""

try:
    import cStringIO.StringIO as BytesIO
except ImportError:
    from io import BytesIO
import struct

class imu_t(object):
    __slots__ = ["utime", "rph", "angRate", "xyz_ddot", "flags"]

    __typenames__ = ["int64_t", "double", "double", "double", "int16_t"]

    __dimensions__ = [None, [3], [3], [3], None]

    FLAG_NEW_MEASUREMENT = 1
    FLAG_OLD_MEASUREMENT = 0

    def __init__(self):
        self.utime = 0
        self.rph = [ 0.0 for dim0 in range(3) ]
        self.angRate = [ 0.0 for dim0 in range(3) ]
        self.xyz_ddot = [ 0.0 for dim0 in range(3) ]
        self.flags = 0

    def encode(self):
        buf = BytesIO()
        buf.write(imu_t._get_packed_fingerprint())
        self._encode_one(buf)
        return buf.getvalue()

    def _encode_one(self, buf):
        buf.write(struct.pack(">q", self.utime))
        buf.write(struct.pack('>3d', *self.rph[:3]))
        buf.write(struct.pack('>3d', *self.angRate[:3]))
        buf.write(struct.pack('>3d', *self.xyz_ddot[:3]))
        buf.write(struct.pack(">h", self.flags))

    def decode(data):
        if hasattr(data, 'read'):
            buf = data
        else:
            buf = BytesIO(data)
        if buf.read(8) != imu_t._get_packed_fingerprint():
            raise ValueError("Decode error")
        return imu_t._decode_one(buf)
    decode = staticmethod(decode)

    def _decode_one(buf):
        self = imu_t()
        self.utime = struct.unpack(">q", buf.read(8))[0]
        self.rph = struct.unpack('>3d', buf.read(24))
        self.angRate = struct.unpack('>3d', buf.read(24))
        self.xyz_ddot = struct.unpack('>3d', buf.read(24))
        self.flags = struct.unpack(">h", buf.read(2))[0]
        return self
    _decode_one = staticmethod(_decode_one)

    def _get_hash_recursive(parents):
        if imu_t in parents: return 0
        tmphash = (0xc6be45f481db0d58) & 0xffffffffffffffff
        tmphash  = (((tmphash<<1)&0xffffffffffffffff) + (tmphash>>63)) & 0xffffffffffffffff
        return tmphash
    _get_hash_recursive = staticmethod(_get_hash_recursive)
    _packed_fingerprint = None

    def _get_packed_fingerprint():
        if imu_t._packed_fingerprint is None:
            imu_t._packed_fingerprint = struct.pack(">Q", imu_t._get_hash_recursive([]))
        return imu_t._packed_fingerprint
    _get_packed_fingerprint = staticmethod(_get_packed_fingerprint)

    def get_hash(self):
        """Get the LCM hash of the struct"""
        return struct.unpack(">Q", imu_t._get_packed_fingerprint())[0]

